/*
Heap sort optimized
*/

#include <iostream>
using namespace std;


template <typename T>
void printarray(T arg[], int length)
{
    for(int n = 0; n < length; ++n)
        cout << arg[n] << ' ';

    cout << endl;
}


template <typename T>
int Input(T A[], int n)
{
    cout << "Enter array elements:";

    for(int i = 0; i < n; i++)
        cin >> A[i];

    return n;
}


template <class E>
void heapsort(E A[], int n)
{
    int pos;

    // build the heap
    for(int i = n / 2 - 1; i >= 0; i--)
    {
        pos = i;

        while(pos < n / 2)
        {
            int j = 2 * pos + 1;

            if(((j + 1) < n) && (A[j] < A[j + 1]))
                j++;

            if(!(A[pos] < A[j]))
                break;

            swap(A[pos], A[j]);
            pos = j;
        }
    }

    // remove and store in non-heap part of array
    for(n--; n > 0; n--)
    {
        swap(A[0], A[n]);
        pos = 0;

        while(pos < n / 2)
        {
            int j = 2 * pos + 1;

            if(((j + 1) < n) && (A[j] < A[j + 1]))
                j++;

            if(!(A[pos] < A[j]))
                break;

            swap(A[pos], A[j]);
            pos = j;
        }
    }
}


int main()
{
    int firstarray[7];
    Input(firstarray, 7);
    cout << "before sort: ";
    printarray(firstarray, 7);

    heapsort(firstarray, 7);
    cout << "after sort: ";
    printarray(firstarray, 7);

    return 0;
}
