/*
Merge sort
*/

#include <iostream>
using namespace std;


template <typename T>
void printarray(T arg[], int length)
{
    for(int n = 0; n < length; ++n)
        cout << arg[n] << ' ';

    cout << endl;
}


template <typename T>
int Input(T A[], int n)
{
    cout << "Enter array elements:";

    for(int i = 0; i < n; i++)
        cin >> A[i];

    return n;
}


template <typename T>
void Merge(T A[], int low, int high, int mid)
{
    int iseg1, iseg2, itemp;
    T temp[high - low + 1];
    iseg1 = low;
    iseg2 = mid + 1;
    itemp = 0;

    while(iseg1 <= mid && iseg2 <= high)
    {
        if(A[iseg1] < A[iseg2])
        {
            temp[itemp] = A[iseg1];
            itemp++;
            iseg1++;
        }
        else
        {
            temp[itemp] = A[iseg2];
            itemp++;
            iseg2++;
        }
    }

    while(iseg1 <= mid)
    {
        temp[itemp] = A[iseg1];
        itemp++;
        iseg1++;
    }

    while(iseg2 <= high)
    {
        temp[itemp] = A[iseg2];
        itemp++;
        iseg2++;
    }

    for(int i = low; i <= high; i++)
    {
        A[i] = temp[i - low];
    }
}


template <typename T>
void MergeSort(T A[], int low, int high)
{
    int mid;

    if(low < high)
    {
        mid = (low + high) / 2;

        MergeSort(A, low, mid);
        MergeSort(A, mid + 1, high);

        Merge(A, low, high, mid);
    }
}


int main()
{
    int firstarray[7];
    Input(firstarray, 7);
    cout << "before sort: ";
    printarray(firstarray, 7);

    MergeSort(firstarray, 0, 7-1);
    cout << "after sort: ";
    printarray(firstarray, 7);

    return 0;
}

