/*
Quick sort
*/

#include <iostream>
using namespace std;


template <typename T>
void printarray(T arg[], int length)
{
    for(int n = 0; n < length; ++n)
        cout << arg[n] << ' ';

    cout << endl;
}


template <typename T>
int Input(T A[], int n)
{
    cout << "Enter array elements:";

    for(int i = 0; i < n; i++)
        cin >> A[i];

    return n;
}


template <typename T>
int part(T A[], int low, int high)
{
    T pivot = A[high];

    while(low < high)
    {
        while(A[low] < pivot)
            low++;

        while(A[high] > pivot)
            high--;

        if(A[low] == A[high])
            low++;
        else if(low < high)
        {
            swap(A[low], A[high]);
        }
    }

    return high;
}

template <typename T>
int part2(T A[], int low, int high)
{
    T pivot = A[low];
    int istore_piv = low;

    for(int k = low + 1; k <= high; k++)
    {
        if(A[k] < pivot)
        {
            istore_piv++;
            swap(A[k], A[istore_piv]);
        }
    }

    swap(A[low], A[istore_piv]);

    return istore_piv;
}


template <typename T>
void quicksort(T A[], int low, int high)
{
    if(low < high)
    {
        int ipiv = part2(A, low, high);
        quicksort(A, low, ipiv - 1);
        quicksort(A, ipiv + 1, high);
    }
}


int main()
{
    int firstarray[7];
    Input(firstarray, 7);
    cout << "before sort: ";
    printarray(firstarray, 7);

    quicksort(firstarray, 0, 7-1);
    cout << "after sort: ";
    printarray(firstarray, 7);

    return 0;
}

