/*
Shell Sort
*/

#include <iostream>
using namespace std;


template <typename T>
void printarray(T arg[], int length)
{
    for(int n = 0; n < length; ++n)
        cout << arg[n] << ' ';

    cout << endl;
}


template <typename T>
int Input(T A[], int n)
{
    cout << "Enter array elements:";

    for(int i = 0; i < n; i++)
        cin >> A[i];

    return n;
}


template <typename T>
void shellsort(T A[], int n)
{
    int i, j, temp, gap;

    for(gap = n / 2; gap > 0; gap /= 2)
    {
        for(i = gap; i < n; i++)
        {
            temp = A[i];

            for(j = i; gap <= j; j -= gap)
            {
                if(temp < A[j - gap])
                    A[j] = A[j - gap];
                else
                    break;
            }

            A[j] = temp;
        }
    }
}


template <typename T>
void shellsort2(T A[], int n)
{
    int gap, i, j;

    for(gap = n / 2; gap > 0; gap /= 2)
    {
        for(i = gap; i < n; i++)
        {
            for(j = i - gap;
                0 <= j && A[j + gap] < A[j];
                j -= gap)
            {
                swap(A[j], A[j + gap]);
            }
        }
    }
}

int main()
{
    int firstarray[7];
    Input(firstarray, 7);
    cout << "before sort: ";
    printarray(firstarray, 7);

    shellsort2(firstarray, 7);
    cout << "after sort: ";
    printarray(firstarray, 7);

    return 0;
}
